#include Comparable 

#Almacena menús.
class Menu
    include Comparable 
    
    #Constructor de la clase Menu. 
    #Argumentos: título del menú, componentes del menú, porciones de cada plato, gramos de cada plato y porcentajes de calorías, grasas, proteínas e hidratos.
    def initialize(titulo, menu, porciones, gramos, porcentajes, &block)
        @titulo = titulo
        @menu = menu
        @porciones = porciones
        @gramos = gramos
        @porcentajes = porcentajes
        @contador = 0
        @n_porcentajes = porcentajes.collect{|i| i.scan(/\d+,?\d+/)}
        
    end
    
    #Definición de las comparaciones para el módulo Comparable
    def <=>(value)
      return nil unless value.instance_of? Menu
      @n_porcentajes <=> value.n_porcentajes
    end
    
    #Muestra el primer plato del menú
    def mostrar_plato
         out = "#{@menu[0]}, " + "#{@porciones[0]}, " + "#{@gramos[0]}"
         return out
    end
    
    #Muestra la ingesta diaria
    def get_ingesta
         out = "#{@titulo[1]}"
         return out
    end
    
    #Muestra todos los platos del menú
    def get_platos
        @explicacion = ""
         @menu.each do |item2|
            @explicacion << "- #{item2}, #{@porciones[@contador]}, #{@gramos[@contador]}\n"
            @contador+=1
        end
       return "#{@explicacion}"
    end
    
    #Muestra el Valor Calórico Total del menú
    def get_vct
        out = "#{@porcentajes[0]}"
         return out
    end
    
    #Muestra el porcentaje de proteínas del menú
    def get_proteinas
        out = "#{@porcentajes[1]}"
         return out
    end
    
    #Muestra el porcentaje de grasas del menú
    def get_grasas
        out = "#{@porcentajes[2]}"
         return out
    end
    
    #Muestra el porcentaje de hidratos del menú
    def get_hidratos
        out = "#{@porcentajes[3]}"
         return out
    end
    
    #Muestra el menú por pantalla
     def to_s
        @explicacion = "#{@titulo[0]} " + "#{@titulo[1]}\n"
         @menu.each do |item2|
            @explicacion << "- #{item2}, #{@porciones[@contador]}, #{@gramos[@contador]}\n"
            @contador+=1
        end
        
        @explicacion << "#{@porcentajes[0]}" + "#{@porcentajes[1]}-" + "#{@porcentajes[2]}-" + "#{@porcentajes[3]}\n"
       return "#{@explicacion}"
    end
    
    attr_accessor :titulo
    attr_accessor :menu
    attr_accessor :porciones
    attr_accessor :gramos
    attr_accessor :porcentajes
    attr_accessor :n_porcentajes
   
end

#Hereda de la clase Menú y además almacena el grupo de alimentos al que pertenece dicho menú.
class Grupos_alimentos < Menu
    
    #Constructor de la clase Grupos_alimentos, que hereda de la clase Menu
    #Argumentos: texto que contiene el grupo de alimentos, título del menú, componentes del menú, porciones de cada plato, gramos de cada plato y porcentajes de calorías, grasas, proteínas e hidratos.
    def initialize(texto, titulo, menu, porciones, gramos, porcentajes)
        @texto = texto
        super(titulo, menu, porciones, gramos, porcentajes)
    end
    
    #Muestra por pantalla un menú y el grupo de alimentos
    def to_s
        imprime = super.to_s + "Menu del grupo: #{texto}\n"
        return imprime
    end
    
    attr_accessor :texto
end

#Hereda de Menú y además almacena el rango de edades para dicho menú.
class Edades < Menu
    #Constructor de la clase Edades, que hereda de la clase Menu
    #Argumentos: texto que contiene el rango de edades, título del menú, componentes del menú, porciones de cada plato, gramos de cada plato y porcentajes de calorías, grasas, proteínas e hidratos.
    def initialize(texto, titulo, menu, porciones, gramos, porcentajes)
        @texto = texto 
        super(titulo, menu, porciones, gramos, porcentajes)
    end
    
    #Muestra por pantalla un menú y el grupo de edades
    def to_s
        imprime = super.to_s + "Edad: #{texto}\n"
        return imprime
    end
    
    attr_accessor :texto
end

class MenuDSL
    attr_accessor :titulo
    attr_accessor :porcentaje
    attr_accessor :platos
    attr_accessor :porcion
    attr_accessor :vct
    attr_accessor :proteinas
    attr_accessor :grasas
    attr_accessor :hidratos
    
     def initialize(name, &block)
        
        @titulo = name
        @porcentaje
        @platos = []
        @porcion
        @vct
        @proteinas
        @grasas
        @hidratos
        @ingesta
    
        if block_given?  
          if block.arity == 1
            yield self
          else
           instance_eval(&block) 
          end
        end
    end
    
    def in_platos(options = {})
        plato = []
        plato << "#{options[:descripcion]}" if options[:descripcion]
        plato << "#{options[:porcion]}" if options[:porcion]
        plato << "#{options[:gramos]}" if options[:gramos]
        #@platos = plato
        @platos.push(plato)
    end
    
    def porcentajes(options = {})
        @vct = "#{options[:vct]}" if options[:vct]
        @proteinas = "#{options[:proteinas]}" if options[:proteinas]
        @grasas = "#{options[:grasas]}" if options[:grasas]
        @hidratos = "#{options[:hidratos]}" if options[:hidratos]
    end
    
    def ingesta(options = {})
        porcentaje = []
        porcentaje << "#{options[:min]}" if options[:min]
        porcentaje << "#{options[:max]}" if options[:max]
        @porcentaje = porcentaje
    
    end
    
    def getPlatos
        @platos.join(" ")
    end
    
    def to_s
        return "#{@titulo} " + "(#{@porcentaje[0]} - #{@porcentaje[1]})\n" + getPlatos  + "\n" + "V.C.T. | % #{@vct} kcal | #{@proteinas}% - #{@grasas}% - #{@hidratos}%\n"
    end
    
    
end