
Node = Struct.new(:value, :next, :previo)

#Lista doblemente enlazada para almacenar elementos.
class Lista
    include Enumerable
    #Contructor de la clase Lista
    def initialize
        @inicio = nil
        @final = nil
    end
    
    #Recorre la lista para el uso del módulo enumerable
    def each
        nodo_aux = @inicio
        while nodo_aux != nil
            yield nodo_aux.value
            nodo_aux = nodo_aux.next
        end
    end
    
    #Devuelve el elemento inicial de la lista
    def get_inicio
       return @inicio 
    end
    
    #Devuelve el elemento final de la linea
    def get_final
       return @final 
    end
    
    #Comprueba si la lista está vacía
    def is_empty
        # @inicio == nil
        r = false
        if(@inicio == nil)
            r = true
        elsif
            r = false
        end
        return r
    end
    
    #Inserta un elemento por el inicio de la lista
    def insertar(elemento) #inserta por el inicio
        nodo_aux = Node.new(elemento, nil, nil)
        if(is_empty())
            @inicio = nodo_aux
            @final = nodo_aux
            @inicio.next = nil
            @inicio.previo = nil
            #@final = @inicio
        elsif
            aux = @inicio
            @inicio = nodo_aux
            @inicio.next = aux
            @inicio.previo = nil
            aux.previo = @inicio
        end
    end
    
    #Inserta un elemento por el final de la lista
    def insertar_final(elemento)
        nodo_aux = Node.new(elemento, nil, nil)
        if(is_empty())
            @inicio = nodo_aux
            @final = nodo_aux
            @inicio.next = nil
            @inicio.previo = nil
            @final.previo = nil
            @final.next = nil
            #@final = @inicio
        elsif
            aux = @final
            @final = nodo_aux
            @final.previo = aux
            @final.next = nil
        end
    end
    
    #Inserta varios elementos por el inicio de la lista
    def insertar_muchos(vector) #inserta muchos por el inicio
        i=0
        
        while i<vector.length
            self.insertar(vector[i])
            i=i+1
        end
    end
    
    #Inserta varios elementos por el final de la lista
    #Se le pasa como argumento un vector con los elementos a insertar en la lista
    def insertar_muchos_final(vector) 
        i=0
        
        while i<vector.length
            self.insertar_final(vector[i])
            i=i+1
        end
    end
    
    #Extrae el inicio de la lista
    def extraer 
        if(is_empty())
            return nil
        elsif
            node_aux = @inicio
            @inicio = @inicio.next
            node_aux.next = nil
            node_aux.previo = nil
            return node_aux.value
        end
    end
    
    #Extrae un elemento del final de la lista
    def extraer_final
        if(is_empty())
            return nil
        elsif
            node_aux = @final
            @final = @final.previo
            if(@final!=nil)
                @final.next=nil
            elsif
                @inicio=nil
            end
            return node_aux.value
        end
    end
    
    attr_accessor :inicio
    attr_accessor :final
end

